## pfstools 2.0.5

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.8)
project(pfstools)

set(CPACK_GENERATOR TGZ)
set(CPACK_SOURCE_GENERATOR TGZ)
# CPack version numbers for release tarball name.
set(CPACK_PACKAGE_VERSION_MAJOR 2)
set(CPACK_PACKAGE_VERSION_MINOR 0)
set(CPACK_PACKAGE_VERSION_PATCH 4)
set(CPACK_SOURCE_IGNORE_FILES
"~$"
"\\\\.cvsignore$"
"^${PROJECT_SOURCE_DIR}.*/CVS/"
"^${PROJECT_SOURCE_DIR}/debian/"
"^${PROJECT_SOURCE_DIR}/old/"
)
include( CPack )

#SET(ZLIB_DIR "e:/zlib/")
#SET(CMAKE_INCLUDE_PATH ${ZLIB_DIR}/include ${CMAKE_INCLUDE_PATH})
#SET(CMAKE_LIBRARY_PATH ${ZLIB_DIR}/ ${ZLIB_DIR}/lib ${CMAKE_LIBRARY_PATH})

if( "${CYGWIN}" STREQUAL "" )
  set(CYGWIN 0)  
endif( "${CYGWIN}" STREQUAL "" )

set (pfstools_VERSION_MAJOR ${CPACK_PACKAGE_VERSION_MAJOR})
set (pfstools_VERSION_MINOR ${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH})
set (pfslib_version 1.2)
set(CMAKE_LEGACY_CYGWIN_WIN32 0)
 
set (MAN_DIR "${CMAKE_INSTALL_PREFIX}/share/man/man1" CACHE PATH "The directory where the man pages are")

include( CheckCXXSourceCompiles )


# ======== Check for OpenMP =======

find_package(OpenMP)
if( OPENMP_FOUND )
  set( HAVE_OpenMP 1 )
else( OPENMP_FOUND )
  set( HAVE_OpenMP 0 )
endif( OPENMP_FOUND )
  

# ======== Has branch prediction =======

check_cxx_source_compiles( "int main() { int x = 0; if( __builtin_expect((x),0) ) x = 1; return 0; }" HAS_BRANCH_PEDICTION )

if( HAS_BRANCH_PREDICTION )
  set( BRANCH_PREDICTION 1 )
else( HAS_BRANCH_PREDICTION )
  set( BRANCH_PREDICTION 0 )
endif( HAS_BRANCH_PREDICTION )

# ======== Find bash =======

# TODO: What if the check fails
find_program (BASH_EXECUTABLE bash)
message( "Using bash: ${BASH_EXECUTABLE}" )

# ======== Find perl =======

find_program (PERL_EXECUTABLE perl)
if( PERL_EXECUTABLE )
	message( "Using perl: ${PERL_EXECUTABLE}" )
else( PERL_EXECUTABLE )
	message( "Perl interpreter not found. Reading multiple exposures (pfsinhdrgen, pfsinme) will not work" )
endif( PERL_EXECUTABLE )

# ======== Build static or dynamic libraries =======

OPTION (BUILD_SHARED_LIBS "Build pfs as a shared library" OFF)
# TODO: Shared libs do not work with VS. Add declspec as explained at: http://www.cmake.org/Wiki/BuildingWinDLL
# Set the LIB_TYPE variable to STATIC
SET (LIB_TYPE STATIC)
IF (BUILD_SHARED_LIBS)
  SET (LIB_TYPE SHARED)
ENDIF (BUILD_SHARED_LIBS)

# ======== Check for getopt, which is missing on Windows ========

check_cxx_source_compiles( "#include \"getopt.h\" \n int main() { return 0; }" HAS_GETOPT )
if( NOT HAS_GETOPT )
  MESSAGE( STATUS "getopt not found, a replacement needs to be compiled. " )
  set( GETOPT_INCLUDE "${PROJECT_SOURCE_DIR}/src/getopt" )
  set( GETOPT_OBJECT "$<TARGET_OBJECTS:getopt>" )
else( NOT HAS_GETOPT )
  MESSAGE( STATUS "getopt found. " )
  set( GETOPT_INCLUDE ".") # work around, cannot pass empty string
  set( GETOPT_OBJECT )
endif( NOT HAS_GETOPT )

set( CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake )

# ======== OpenEXR ===========

OPTION(WITH_OpenEXR "Compile with OpenEXR library" ON)

if( WITH_OpenEXR )

find_package (OpenEXR)
if( NOT OPENEXR_FOUND )
MESSAGE( STATUS "OpenEXR not found. The following command will not be
compiled: pfsinexr pfsoutexr. " )
endif( NOT OPENEXR_FOUND )

endif( WITH_OpenEXR )

# ======== Image Magick ===========

OPTION(WITH_ImageMagick "Use ImageMagick library" ON)

if( WITH_ImageMagick )

find_package(ImageMagick COMPONENTS Magick++ MagickCore)
if( NOT ImageMagick_FOUND )
MESSAGE( STATUS "ImageMagick not found. The following commands will not be
compiled: pfsinimgmagick pfsoutimgmagick pfsouthdrhtml. " )
endif( NOT ImageMagick_FOUND )

else( WITH_ImageMagick )

      set( ImageMagick_FOUND OFF )

endif( WITH_ImageMagick )

message( "ImageMagick CFLAGS: " ${ImageMagick_INCLUDE_DIRS} )

# ======== NetPBM ===========

#include( ${PROJECT_SRC_DIR}/cmake/FindNETPBM.cmake )

OPTION(WITH_NetPBM "Use NetPBM library" ON)

if( WITH_NetPBM )

    find_package(NETPBM)
    if( NOT NETPBM_FOUND )
    	MESSAGE( STATUS "NetPBM not found. The following commands will
    not be compiled: pfsinppm pfsoutppm. " )
    endif( NOT NETPBM_FOUND )

else( WITH_NetPBM )

      set( NETPBM_FOUND OFF )

endif( WITH_NetPBM )

# ======== TIFF ===========

#include( ${PROJECT_SRC_DIR}/cmake/FindTIDD.cmake )

OPTION(WITH_TIFF "Use TIFF library" ON)

if( WITH_TIFF )

    find_package(TIFF)
    if( NOT TIFF_FOUND )
    	MESSAGE( STATUS "TIFF not found. The following commands will
    not be compiled: pfsintiff pfsouttiff. " )
    endif( NOT TIFF_FOUND )

else( WITH_TIFF )

      set( NETPBM_FOUND OFF )

endif( WITH_TIFF )

# ======== QT ===========

OPTION(WITH_QT "Use QT library" ON)

if( WITH_QT )

    find_package(Qt4)
    if( NOT QT_FOUND )
    	MESSAGE( STATUS "Qt4 library not found. The following commands
    will not be compiled: pfsview. " )
    else( NOT QT_FOUND )
        MESSAGE( STATUS "Qt4 found" )
    endif( NOT QT_FOUND )

else( WITH_QT )

      set( QT_FOUND OFF )

endif( WITH_QT )

# ======== Matlab ===========

OPTION(WITH_MATLAB "Compile Matlab MEX files" ON)

SET (MATLAB_DEST_DIR "${CMAKE_INSTALL_PREFIX}/share/pfstools/pfstools_matlab"
CACHE PATH  "Copy matlab functions to this directory")

if( WITH_MATLAB )
  find_package(MATLAB)

  if( MATLAB_FOUND )
    message(STATUS "matlab found.")
  elseif( MATLAB_FOUND )
    message( STATUS "Matlab or mex compiler not found. Matlab integration will not be compiled." )
  endif( MATLAB_FOUND )
  
endif( WITH_MATLAB )


#include( FindPkgConfig.cmake )

# ======== OpenGL ===========

OPTION(WITH_pfsglview "Compile pfsglview, requires OpenGL and GLUT" ON)

if( WITH_pfsglview )

find_path(OPENGL_INCLUDE_DIR GL/gl.h )

find_package(OpenGL )
find_package(GLUT )

if( NOT OPENGL_FOUND )
	MESSAGE( STATUS "OpenGL not found. The following command will not be
compiled: pfsglview. " )
endif( NOT OPENGL_FOUND )

if( NOT GLUT_FOUND )
	MESSAGE( STATUS "GLUT not found. The following command will not be
compiled: pfsglview. " )
endif( NOT GLUT_FOUND )

endif( WITH_pfsglview )

# ========= FFTW  ===========

OPTION(WITH_FFTW "Use fftw to speed up some operations" ON)

if( WITH_FFTW )

  find_package (FFTW)

  if( NOT FFTW_FOUND )
    MESSAGE( STATUS "FFTW library not found. Acceleration for pfstmo_durand02 disabled. " )
    set( HAVE_FFTW3F 0 )
    set( HAVE_FFTW3 0 )
  else( NOT FFTW_FOUND )
    set( HAVE_FFTW3F 1 )
    set( HAVE_FFTW3 1 )
  endif( NOT FFTW_FOUND )

else( WITH_FFTW )
  set( HAVE_FFTW3F 0 )
  set( HAVE_FFTW3 0 )
endif( WITH_FFTW )


# ========= GSL  ===========

OPTION(WITH_GSL "Use Gnu Scientific Libarary required for some TMOs" ON)

if( WITH_GSL )

find_package (GSL)

if( NOT GSL_FOUND )
	MESSAGE( STATUS "GSL library not found. pfstmo_mantiuk08 will not be compiled." )
endif( NOT GSL_FOUND )

endif( WITH_GSL )


# ======== HDRVC ===========
# This is an experimental implementation of HDR-MPEG codec, not included in the official release.
OPTION(WITH_HDRVC "Compile HDRVC (internal release only)" OFF)

# ======== MKOCTFILE/OCTAVE ===========

OPTION(WITH_Octave "Compile Octave files" ON)

SET (OCTAVE_DEST_DIR "" CACHE PATH  "Install octave .m and .oct files in this directory")

if( OCTAVE_DEST_DIR )
  set( OCTAVE_OCT_DIR ${OCTAVE_DEST_DIR} )
  set( OCTAVE_M_DIR ${OCTAVE_DEST_DIR} )
else( OCTAVE_DEST_DIR )
 execute_process(COMMAND octave-config --oct-site-dir OUTPUT_VARIABLE OCTAVE_OCT_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
 set( OCTAVE_OCT_DIR "${OCTAVE_OCT_DIR}/pfstools" )
 execute_process(COMMAND octave-config --m-site-dir OUTPUT_VARIABLE OCTAVE_M_DIR OUTPUT_STRIP_TRAILING_WHITESPACE)
 set( OCTAVE_M_DIR "${OCTAVE_M_DIR}/pfstools" )
endif( OCTAVE_DEST_DIR ) 

if( WITH_Octave )
  
  find_program(MKOCTFILE mkoctfile)
  if(NOT MKOCTFILE)
    message(STATUS "Failed to find mkoctfile. Maybe liboctave-dev is not installed.")
  endif()
  if(MKOCTFILE)
    message(STATUS "mkoctfile found.")
  endif()

endif( WITH_Octave )

# ======== OpenCV ===========

OPTION(WITH_OpenCV "Use OpenCV library requires for pfsalign" ON)

if( WITH_OpenCV )

  find_package( OpenCV )

  if( NOT OpenCV_FOUND )
    message( "OpenCV library not found. 'pfsalign' will not be compiled" )
  else( NOT OpenCV_FOUND )
    message(STATUS "OpenCV library found.")  
  endif( NOT OpenCV_FOUND )

endif( WITH_OpenCV )

# ======== libexif ==========

find_package(EXIF)
if( NOT EXIF_FOUND )
    message( "EXIF library (libexif) not found. 'pfsalign' will not be compiled" )
else( NOT EXIF_FOUND )
    message(STATUS "libexif library found.")  
endif( NOT EXIF_FOUND )

# ======== Config and sub dirs ===========

set(PKG_DATADIR "${CMAKE_INSTALL_PREFIX}/share/pfstools")
configure_file (
  "${PROJECT_SOURCE_DIR}/cmake_config.h.in"
  "${PROJECT_BINARY_DIR}/config.h"
  )

add_subdirectory (src)

=== src/matlab/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs")

#include_directories ("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs" ${MATLAB_INCLUDE_DIR})

link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

execute_process(COMMAND ${MATLAB_ROOT}/bin/mexext OUTPUT_VARIABLE MEX_EXT OUTPUT_STRIP_TRAILING_WHITESPACE)

message( "Matlab: mexext: ${MEX_EXT}" )
set(SRCMEX pfsclose.cpp pfsopen.cpp pfspopen.cpp pfsput.cpp pfsget.cpp pfs_transform_colorspace.cpp pfspclose.cpp) 

set(SRCM Contents.m pfs_read_image.m pfs_read_luminance.m
pfs_read_rgb.m pfs_read_xyz.m pfs_shell.m pfs_test_shell.m
pfs_write_image.m pfs_write_luminance.m pfs_write_rgb.m
pfs_write_xyz.m pfsview.m pfsview_rgb.m ) 

cmake_policy(SET CMP0018 OLD)
#cmake_policy(SET CMP0042 OLD) This policy is not recognized in cmake version 2.8.12.2

SET( CMAKE_CXX_COMPILER ${MATLAB_MEX} )
SET( CMAKE_C_COMPILER   ${MATLAB_MEX} )
# Suffix and Prefix of the output target file
SET( CMAKE_SHARED_LIBRARY_SUFFIX ".${MEX_EXT}" )  # set suffix to .mexa64
SET( CMAKE_SHARED_LIBRARY_PREFIX )      # remove the "lib" prefix
 
# Variables controlling the build-phrase
SET( CMAKE_CXX_FLAGS "-cxx -largeArrayDims" )
#SET( CMAKE_CXX_FLAGS "-cxx -largeArrayDims CXXFLAGS='$$CXXFLAGS -std=c++11'" )
SET( CMAKE_SHARED_LIBRARY_CXX_FLAGS )       # remove the -fPIC option. mex does not accept the "-fPIC" option
 
SET( CMAKE_CXX_COMPILE_OBJECT 
    "<CMAKE_CXX_COMPILER> <DEFINES> <FLAGS> -outdir <OBJECT_DIR> -c <SOURCE>; mv <OBJECT_DIR>/$$(basename <SOURCE> .cpp ).o <OBJECT>"
#    "<CMAKE_CXX_COMPILER> <DEFINES> <FLAGS> -outdir <OBJECT_DIR> -c <SOURCE>"
)
 
# Variables controlling the linking-phase
SET( CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS )    # remove -shared options. mex does not accept the "-shared" option
 
SET(
    CMAKE_CXX_CREATE_SHARED_LIBRARY
    "<CMAKE_CXX_COMPILER> -cxx <LINK_FLAGS> <CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS> -output <TARGET> <OBJECTS> <LINK_LIBRARIES> LDFLAGS='$LDFLAGS -static-libstdc++'"
)

#

#SET( CMAKE_SKIP_RPATH TRUE ) 
# Variables controlling the installation RPATH
SET( CMAKE_INSTALL_RPATH "\$ORIGIN" )

# CMake will reset RPATH at the installation phase, so we need to specify CMAKE_INSTALL_RPATH

SET( CMAKE_SKIP_RPATH TRUE ) 

MESSAGE( STATUS "mex.cmake is loaded.\n" )
 
 
## To add an mex file, you can:
#  ADD_LIBRARY( myprogram SHARED myprogram.cxx )
## Make sure you specify it as SHARED, and make sure you use the cxx extension. 

add_definitions(-DMATLAB_MEX_FILE) 
foreach(SRC ${SRCMEX}) 
  get_filename_component(MEXNAME ${SRC} NAME_WE) 
  add_library(${MEXNAME} SHARED ${SRC} mex_utils.cpp ${MEXDEFFILE}) 
#  target_link_libraries(${MEXNAME} pfs ${MATLAB_LIBRARIES}) 
  target_link_libraries(${MEXNAME} pfs ) 
#  set_target_properties(${MEXNAME} PROPERTIES PREFIX "" SUFFIX 
#".${MEX_EXT}") 

  install (TARGETS ${MEXNAME} DESTINATION ${MATLAB_DEST_DIR})
  install (FILES ${MEXNAME}.m DESTINATION ${MATLAB_DEST_DIR})

endforeach(SRC) 

foreach(SRC ${SRCM}) 
  install (FILES ${SRC} DESTINATION ${MATLAB_DEST_DIR})
endforeach(SRC)

=== debian/changelog ===
pfstools (2.0.5-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 19 Jun 2016 11:52:33 +0200

pfstools (2.0.5-1) experimental; urgency=medium

  * Move Vcs-* from git/http to https.
  * New upstream version.
    + Drop 21_fedora_maptype.patch, 22_octave_install_dirs.patch.
    + Add 23_octavesystemdirs.diff to use octave system directories instead
      of local, site-specific ones. Stop passing these as arguments to
      dh_auto_configure in debian/rules.
    + Stop trying to ship removed TODO.
  * Build with hardening=+bindnow.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 04 Jun 2016 15:47:03 +0200

=== debian/control ===
Source: pfstools
Section: graphics
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Sebastian Harl <tokkee@debian.org>, Andreas Metzler <ametzler@debian.org>
Build-Depends: debhelper (>= 9), gfortran,
 cmake, libqt4-dev, libmagick++-dev, libtiff-dev, libopenexr-dev,
 libnetpbm10-dev, liboctave-dev, texlive-latex-base, freeglut3-dev,
 libgsl-dev
Standards-Version: 3.9.8
Homepage: http://pfstools.sourceforge.net/
Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/pfstools.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-phototools/pfstools.git

Package: pfstools
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pfsglview | pfsview, pfstmo, octave, octave-signal, octave-pfstools
Suggests: dcraw, exrtools, imagemagick
Description: command line HDR manipulation programs
 pfstools is a set of command line (and two GUI) programs for reading,
 writing, manipulating and viewing high-dynamic range (HDR) images and video
 frames. All programs in this package exchange data using a simple generic
 file format (pfs) for HDR data. It is an attempt to integrate existing file
 formats by providing a simple data format that can be used to exchange data
 between applications.
 .
 The concept of pfstools is similar to netpbm for low-dynamic range images.

Package: pfsglview
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pfstools
Replaces: pfstools (<< 1.6.2-2)
Description: command line HDR manipulation programs (OpenGL/GLUT viewer)
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications.
 .
 This package contains a viewer implemented in OpenGL/GLUT.

Package: pfsview
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pfstools
Replaces: pfstools (<< 1.6.2-2)
Description: command line HDR manipulation programs (Qt viewer)
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications.
 .
 This package contains a viewer implemented in Qt.

Package: pfstools-dbg
Section: debug
Architecture: any
Priority: extra
Depends: pfstools (= ${binary:Version}), pfsglview (= ${binary:Version}),
 pfsview (= ${binary:Version}), libpfs2 (= ${binary:Version}),
 ${misc:Depends}
Description: command line HDR manipulation programs (debugging symbols)
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications.
 .
 This package contains the debugging symbols for the pfstools binaries and the
 shared library.

Package: libpfs-dev
Section: libdevel
Architecture: any
Depends: libpfs2 (= ${binary:Version}), ${misc:Depends}
Description: C++ library to read and write pfs files (development files)
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications. This library can be used to write custom
 applications that can integrate with the existing pfstools programs.
 .
 This package contains the header files and the static library.

Package: libpfs2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ library to read and write pfs files
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications. This library can be used to write custom
 applications that can integrate with the existing pfstools programs.
 .
 This package contains the shared library.

Package: octave-pfstools
Section: math
Architecture: any
Depends: octave, ${shlibs:Depends}, ${misc:Depends}
Description: octave bindings for pfstools
 PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
 existing file formats by providing a simple data format that can be used to
 exchange data between applications.
 .
 This package contains octave bindings to read and write PFS files.

Package: pfstmo
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pfstools
Description: set of tone mapping operators
 This package contains a set of state-of-the-art tone mapping operators. Tone
 mapping is a technique used to approximately map the appearance of
 high-dynamic range (HDR) images to media with more limited dynamic range. The
 operators are suitable for processing of both static images and animations.
 .
 The operators are embedded in a flexible framework (pfstools) which provides
 a unified input/output mechanism and a modular architecture for the filtering
 of the image data. Various file formats for static images and video are
 transparently supported and the High Dynamic Range data are processed
 modularly through a Unix piping mechanism.

## pfstools 2.0.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 # CPack version numbers for release tarball name.
 set(CPACK_PACKAGE_VERSION_MAJOR 2)
 set(CPACK_PACKAGE_VERSION_MINOR 0)
-set(CPACK_PACKAGE_VERSION_PATCH 4)
+set(CPACK_PACKAGE_VERSION_PATCH 6)
 set(CPACK_SOURCE_IGNORE_FILES
 "~$"
 "\\\\.cvsignore$"
@@ -199,7 +199,7 @@
   find_package(MATLAB)
 
   if( MATLAB_FOUND )
-    message(STATUS "matlab found.")
+    message(STATUS "matlab found. mex command: ${MATLAB_MEX}")
   elseif( MATLAB_FOUND )
     message( STATUS "Matlab or mex compiler not found. Matlab integration will not be compiled." )
   endif( MATLAB_FOUND )

=== src/matlab/CMakeLists.txt ===

# PROJECT_BINARY_DIR contains config.h and is thus needed
include_directories ("${PROJECT_SOURCE_DIR}/src/pfs" "${PROJECT_BINARY_DIR}")

if( CYGWIN )
	# Cygwin normally does not require getopt but matlab sourves will be compiled with an external matlab 
	# compiler, most probably Visual Studio
	include_directories ("${PROJECT_SOURCE_DIR}/src/getopt")
	set( SCRIPT_EXT ".bat" )
else( CYGWIN )
	set( SCRIPT_EXT "" )
endif( CYGWIN )

#include_directories ("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs" ${MATLAB_INCLUDE_DIR})
#link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

execute_process(COMMAND ${MATLAB_ROOT}/bin/mexext${SCRIPT_EXT} OUTPUT_VARIABLE MEX_EXT OUTPUT_STRIP_TRAILING_WHITESPACE)

message( "Matlab: mexext: ${MEX_EXT}" )
set(SRCMEX pfsclose.cpp pfsopen.cpp pfspopen.cpp pfsput.cpp pfsget.cpp pfs_transform_colorspace.cpp pfspclose.cpp) 

set(SRCM Contents.m pfs_read_image.m pfs_read_luminance.m
pfs_read_rgb.m pfs_read_xyz.m pfs_shell.m pfs_test_shell.m
pfs_write_image.m pfs_write_luminance.m pfs_write_rgb.m
pfs_write_xyz.m pfsview.m pfs_fix_path.m pfs_exec.m) 

cmake_policy(SET CMP0018 OLD)
#cmake_policy(SET CMP0042 OLD) This policy is not recognized in cmake version 2.8.12.2

SET( CMAKE_CXX_COMPILER ${MATLAB_MEX} )
SET( CMAKE_C_COMPILER   ${MATLAB_MEX} )
# Suffix and Prefix of the output target file
SET( CMAKE_SHARED_LIBRARY_SUFFIX ".${MEX_EXT}" )  # set suffix to .mexa64
SET( CMAKE_SHARED_LIBRARY_PREFIX )      # remove the "lib" prefix 
 
# Variables controlling the build-phrase
SET( CMAKE_CXX_FLAGS "-cxx -largeArrayDims" )
#SET( CMAKE_CXX_FLAGS "-cxx -largeArrayDims CXXFLAGS='$$CXXFLAGS -std=c++11'" )
SET( CMAKE_SHARED_LIBRARY_CXX_FLAGS )       # remove the -fPIC option. mex does not accept the "-fPIC" option
 
get_property(inc_dirs DIRECTORY PROPERTY INCLUDE_DIRECTORIES)
set( INC_FLAGS "" )
foreach( IDIR ${inc_dirs} )
	set( INC_FLAGS "${INC_FLAGS} -I${IDIR}" )
endforeach( IDIR )
 
 
if( CYGWIN ) 
	# This is ugly but necessary to work around CMake limitations
	# The compiled objects need to be copied to ensure that the dependency check works
	# Linker expects the obejcts to be in the <OBJECT_DIR> so we need to have them there as well
	SET( CMAKE_CXX_COMPILE_OBJECT 
		"<CMAKE_CXX_COMPILER> <DEFINES> <FLAGS> ${INC_FLAGS} -outdir <OBJECT_DIR> -c <SOURCE>; cp <OBJECT_DIR>/$$(basename <SOURCE> .cpp ).obj <OBJECT>"
	)
else( CYGWIN ) 
	SET( CMAKE_CXX_COMPILE_OBJECT 
#		"<CMAKE_CXX_COMPILER> GCC='/usr/bin/gcc-4.7' <DEFINES> <FLAGS> ${INC_FLAGS} -outdir <OBJECT_DIR> -c <SOURCE>; mv <OBJECT_DIR>/$$(basename <SOURCE> .cpp ).o <OBJECT>"
		"<CMAKE_CXX_COMPILER> <DEFINES> <FLAGS> -outdir <OBJECT_DIR> -c <SOURCE>"
	)
endif( CYGWIN ) 

 
# Variables controlling the linking-phase
SET( CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS )    # remove -shared options. mex does not accept the "-shared" option
 
SET(
    CMAKE_CXX_CREATE_SHARED_LIBRARY
    "<CMAKE_CXX_COMPILER> -cxx <LINK_FLAGS> <CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS> -output <TARGET> <OBJECTS> <LINK_LIBRARIES>"
#    "<CMAKE_CXX_COMPILER> GCC='/usr/bin/gcc-4.7' -cxx <LINK_FLAGS> <CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS> -output <TARGET> <OBJECTS> <LINK_LIBRARIES> LDFLAGS='$LDFLAGS -static-libstdc++'"
)

#

#SET( CMAKE_SKIP_RPATH TRUE ) 
# Variables controlling the installation RPATH
SET( CMAKE_INSTALL_RPATH "\$ORIGIN" )

# CMake will reset RPATH at the installation phase, so we need to specify CMAKE_INSTALL_RPATH

SET( CMAKE_SKIP_RPATH TRUE ) 

MESSAGE( STATUS "mex.cmake is loaded.\n" )
 
# Since Matlab tends to use ancient version of stdc++, dynamic linkimg with pfs library 
# causes heaps of problems. It is better to statically add required files. 
SET( PFS_LIB_SRC ${PROJECT_SOURCE_DIR}/src/pfs/pfs.cpp ${PROJECT_SOURCE_DIR}/src/pfs/colorspace.cpp )
 
## To add an mex file, you can:
#  ADD_LIBRARY( myprogram SHARED myprogram.cxx )
## Make sure you specify it as SHARED, and make sure you use the cxx extension. 

add_definitions(-DMATLAB_MEX_FILE) 
foreach(SRC ${SRCMEX}) 
  get_filename_component(MEXNAME ${SRC} NAME_WE) 
  add_library(${MEXNAME} SHARED ${SRC} mex_utils.cpp ${PFS_LIB_SRC} ${MEXDEFFILE}) 
#  target_link_libraries(${MEXNAME} pfs ${MATLAB_LIBRARIES}) 
#  target_link_libraries(${MEXNAME} pfs ) 
#  set_target_properties(${MEXNAME} PROPERTIES PREFIX "" SUFFIX 
#".${MEX_EXT}") 

  install (TARGETS ${MEXNAME} DESTINATION ${MATLAB_DEST_DIR})
  install (FILES ${MEXNAME}.m DESTINATION ${MATLAB_DEST_DIR})

endforeach(SRC) 

foreach(SRC ${SRCM}) 
  install (FILES ${SRC} DESTINATION ${MATLAB_DEST_DIR})
endforeach(SRC)

=== src/tmo/mai11/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/"
"${PROJECT_SOURCE_DIR}/src/pfs" "${PROJECT_SOURCE_DIR}/src/tmo/pfstmo")
if( NOT HAS_GETOPT )
	include_directories ("${GETOPT_INCLUDE}")
endif( NOT HAS_GETOPT )
link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

set(TRG pfstmo_mai11)
add_executable(${TRG} ${TRG}.cpp compression_tmo.cpp "${GETOPT_OBJECT}")
target_link_libraries(${TRG} pfs)
install (TARGETS ${TRG} DESTINATION bin)
install (FILES ${TRG}.1 DESTINATION ${MAN_DIR})

=== debian/changelog ===
pfstools (2.0.6-4) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 18 Nov 2017 11:22:44 +0100

pfstools (2.0.6-3) experimental; urgency=low

  * Pull 30_Upgrade-to-Qt5.patch from upstream qt5-upgrade branch and
    update b-d for qt5 (libqt4-dev -> qtbase5-dev). Closes: #875094
  * Upgrade pfsglview/pfsview recommends on pfstools to a dependency since
    pfstools is required for viewing EXR files.
  * Sync priorities with override file.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 14 Oct 2017 15:16:36 +0200

pfstools (2.0.6-2) unstable; urgency=low

  * 25_Multiple-typo-fixes-suggested-by-lintian.patch Fix some typoes.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 06 Aug 2017 14:52:51 +0200

pfstools (2.0.6-1) experimental; urgency=medium

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 18 Mar 2017 14:24:07 +0100

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Sebastian Harl <tokkee@debian.org>, Andreas Metzler <ametzler@debian.org>
 Build-Depends: debhelper (>= 9), gfortran,
- cmake, libqt4-dev, libmagick++-dev, libtiff-dev, libopenexr-dev,
+ cmake, qtbase5-dev, libmagick++-dev, libtiff-dev, libopenexr-dev,
  libnetpbm10-dev, liboctave-dev, texlive-latex-base, freeglut3-dev,
  libgsl-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Homepage: http://pfstools.sourceforge.net/
 Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/pfstools.git
 Vcs-Browser: https://anonscm.debian.org/git/pkg-phototools/pfstools.git
@@ -29,8 +29,7 @@
 
 Package: pfsglview
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: pfstools
+Depends: ${shlibs:Depends}, ${misc:Depends}, pfstools (= ${binary:Version})
 Replaces: pfstools (<< 1.6.2-2)
 Description: command line HDR manipulation programs (OpenGL/GLUT viewer)
  PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
@@ -41,8 +40,7 @@
 
 Package: pfsview
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: pfstools
+Depends: ${shlibs:Depends}, ${misc:Depends}, pfstools (= ${binary:Version})
 Replaces: pfstools (<< 1.6.2-2)
 Description: command line HDR manipulation programs (Qt viewer)
  PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
@@ -54,7 +52,6 @@
 Package: pfstools-dbg
 Section: debug
 Architecture: any
-Priority: extra
 Depends: pfstools (= ${binary:Version}), pfsglview (= ${binary:Version}),
  pfsview (= ${binary:Version}), libpfs2 (= ${binary:Version}),
  ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for pfstools
#
# Written by Sebastian Harl <tokkee@debian.org>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

MDIR = $(shell octave-config  --print LOCALFCNFILEDIR)
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

confflags = -DCMAKE_EXPORT_COMPILE_COMMANDS=true -DBUILD_SHARED_LIBS=ON
# Matlab is not available in Debian.
confflags += -DWITH_MATLAB=false

# These libraries are not available / unusable in Debian.
#confflags += --disable-jpeghdr --disable-gdal

export DEB_CFLAGS_MAINT_APPEND := -Wall
export DEB_CXXFLAGS_MAINT_APPEND := -Wall
export DEB_BUILD_MAINT_OPTIONS := hardening=+bindnow

override_dh_auto_configure:
	dh_auto_configure --verbose -- \
		$(confflags)

override_dh_auto_build:
	dh_auto_build -v
	cd doc && pdflatex pfs_format_spec.tex && \
		pdflatex pfs_format_spec.tex

override_dh_auto_install:
	dh_auto_install --verbose
	chmod 644 debian/tmp/$(MDIR)/pfstools/*
	# these binaries are not available
	rm -vf debian/tmp/usr/share/man/man1/pfs*jpeghdr.1 \
		debian/tmp/usr/share/man/man1/pfsingdal.1

override_dh_install:
	dh_install
	# these files have been installed twice by dh_install
	rm -vf debian/pfstools/usr/bin/pfs*view debian/pfstools/usr/bin/pfsv \
		debian/pfstools/usr/share/man/man1/pfsv.1 \
		debian/pfstools/usr/share/man/man1/pfs*view.1 \
		debian/pfstools/usr/bin/pfstmo* \
		debian/pfstools/usr/share/man/*/pfstmo*

override_dh_strip:
	dh_strip --dbg-package=pfstools-dbg
	# mkoctfile removes any symbol table and relocation information from the
	# .oct files making them unusable for the -dbg package
	rm -rf debian/pfstools-dbg/usr/lib/debug/usr/lib/octave/

override_dh_compress:
	dh_compress -X.pdf

%:
	dh $@

## pfstools 2.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,8 +5,8 @@
 set(CPACK_SOURCE_GENERATOR TGZ)
 # CPack version numbers for release tarball name.
 set(CPACK_PACKAGE_VERSION_MAJOR 2)
-set(CPACK_PACKAGE_VERSION_MINOR 0)
-set(CPACK_PACKAGE_VERSION_PATCH 6)
+set(CPACK_PACKAGE_VERSION_MINOR 1)
+set(CPACK_PACKAGE_VERSION_PATCH 0)
 set(CPACK_SOURCE_IGNORE_FILES
 "~$"
 "\\\\.cvsignore$"
@@ -174,13 +174,13 @@
 
 if( WITH_QT )
 
-    find_package(Qt4)
-    if( NOT QT_FOUND )
-    	MESSAGE( STATUS "Qt4 library not found. The following commands
+  find_package(Qt5 COMPONENTS Widgets)
+    if( NOT Qt5Widgets_FOUND)
+    	MESSAGE( STATUS "Qt5 library not found. The following commands
     will not be compiled: pfsview. " )
-    else( NOT QT_FOUND )
-        MESSAGE( STATUS "Qt4 found" )
-    endif( NOT QT_FOUND )
+    else( NOT Qt5Widgets_FOUND )
+        MESSAGE( STATUS "Qt5 found" )
+    endif( NOT Qt5Widgets_FOUND )
 
 else( WITH_QT )
 
@@ -194,6 +194,9 @@
 
 SET (MATLAB_DEST_DIR "${CMAKE_INSTALL_PREFIX}/share/pfstools/pfstools_matlab"
 CACHE PATH  "Copy matlab functions to this directory")
+
+SET (MEXGCC ""
+CACHE PATH "gcc compiler to use with MEX, for example MEXGCC=/usr/bin/gcc-4.7")
 
 if( WITH_MATLAB )
   find_package(MATLAB)

=== src/CMakeLists.txt ===
if( NOT HAS_GETOPT )
  add_subdirectory (getopt)
endif( NOT HAS_GETOPT )

add_subdirectory (pfs) 
add_subdirectory (fileformat) 
add_subdirectory (filter)

if( ImageMagick_FOUND )
    add_subdirectory (hdrhtml)
endif( ImageMagick_FOUND )

if( Qt5Widgets_FOUND )
	add_subdirectory (pfsview)
endif( Qt5Widgets_FOUND )

if( MATLAB_FOUND )
    add_subdirectory (matlab)
endif( MATLAB_FOUND )

if( OPENGL_FOUND AND GLUT_FOUND )
    add_subdirectory (pfsglview)
endif( OPENGL_FOUND AND GLUT_FOUND )

if( WITH_HDRVC )
	add_subdirectory (hdrvc)
endif( WITH_HDRVC )

if( MKOCTFILE )
	add_subdirectory (octave)
endif( MKOCTFILE )

add_subdirectory (tmo)
add_subdirectory (camera)

=== src/camera/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/"
"${PROJECT_SOURCE_DIR}/src/pfs" "${CMAKE_CURRENT_SOURCE_DIR}")

link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

set(TRG pfshdrcalibrate)
add_executable(${TRG} ${TRG}.cpp  responses.cpp robertson02.cpp  mitsunaga99.cpp  mitsunaga99_numerical.cpp nrutil.cpp "${GETOPT_OBJECT}")			  
target_link_libraries(${TRG} pfs)
install (TARGETS ${TRG} DESTINATION bin)
install (FILES ${TRG}.1 DESTINATION ${MAN_DIR})

if( OpenCV_FOUND AND EXIF_FOUND )

	set(TRG pfsalign)
	add_executable(${TRG} ${TRG}.cpp  "${GETOPT_OBJECT}")			  
	target_link_libraries(${TRG} pfs ${OpenCV_LIBS}
	${EXIF_LIBRARIES})
	include_directories( ${EXIF_INCLUDE_DIRS} )
	install (TARGETS ${TRG} DESTINATION bin)
	install (FILES ${TRG}.1 DESTINATION ${MAN_DIR})

endif( OpenCV_FOUND AND EXIF_FOUND )


# Shell scripts
set(SCRIPTS dcraw2hdrgen jpeg2hdrgen pfsinme pfsplotresponse pfsinhdrgen) 

foreach(SCRIPT ${SCRIPTS}) 

	# Replace the tag with the path to bash
	file(READ ${CMAKE_CURRENT_SOURCE_DIR}/${SCRIPT}.in file_content)
	string(REGEX REPLACE "@BASH_PATH@" "${BASH_EXECUTABLE}" file_content "${file_content}")
	string(REGEX REPLACE "@PERL_PATH@" "${PERL_EXECUTABLE}" file_content "${file_content}")
	file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}" "${file_content}")	

	install (FILES "${CMAKE_CURRENT_BINARY_DIR}/${SCRIPT}" 
         PERMISSIONS OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE OWNER_WRITE WORLD_READ GROUP_READ OWNER_READ
         DESTINATION bin)	
		 
	install (FILES ${SCRIPT}.1 DESTINATION ${MAN_DIR})
		 
endforeach(SCRIPT)

=== src/fileformat/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/" "${PROJECT_SOURCE_DIR}/src/pfs")
if( NOT HAS_GETOPT )
	include_directories ("${GETOPT_INCLUDE}")
endif( NOT HAS_GETOPT )

link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

set( SHELL_CMDS pfsin pfsout pfsindcraw )
foreach(SHCMD ${SHELL_CMDS}) 
  # Replace the tag with the path to bash
  add_custom_command( OUTPUT ${SHCMD}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${SHCMD}.in
    COMMAND sed -e "'s;@BASH_PATH@;${BASH_EXECUTABLE};g'" ${CMAKE_CURRENT_SOURCE_DIR}/${SHCMD}.in >${CMAKE_CURRENT_BINARY_DIR}/${SHCMD} )
  add_custom_target(${SHCMD}_sh ALL DEPENDS ${SHCMD})
endforeach(SHCMD)
    
#file(READ ${CMAKE_CURRENT_SOURCE_DIR}/pfsin.in file_content)
#string(REGEX REPLACE "@BASH_PATH@" "${BASH_EXECUTABLE}" file_content "${file_content}")
#file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/pfsin" "${file_content}")	

#file(READ ${CMAKE_CURRENT_SOURCE_DIR}/pfsout.in file_content)
#string(REGEX REPLACE "(@BASH_PATH@)" "${BASH_EXECUTABLE}" file_content "${file_content}")
#file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/pfsout" "${file_content}")	

#file(READ ${CMAKE_CURRENT_SOURCE_DIR}/pfsindcraw.in file_content)
#string(REGEX REPLACE "(@BASH_PATH@)" "${BASH_EXECUTABLE}" file_content "${file_content}")
#file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/pfsindcraw" "${file_content}")	


install (FILES "${CMAKE_CURRENT_BINARY_DIR}/pfsin" "${CMAKE_CURRENT_BINARY_DIR}/pfsout" 
         "${CMAKE_CURRENT_BINARY_DIR}/pfsindcraw" 
         PERMISSIONS OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE OWNER_WRITE WORLD_READ GROUP_READ OWNER_READ
         DESTINATION bin)

install (FILES pfsin.1 DESTINATION ${MAN_DIR})
install (FILES pfsindcraw.1 DESTINATION ${MAN_DIR})
install (FILES pfsout.1 DESTINATION ${MAN_DIR})

add_executable(pfsinyuv pfsinyuv.cpp "${GETOPT_OBJECT}")
target_link_libraries(pfsinyuv pfs)
install (TARGETS pfsinyuv DESTINATION bin)
install (FILES pfsinyuv.1 DESTINATION ${MAN_DIR})

add_executable(pfsoutyuv pfsoutyuv.cpp "${GETOPT_OBJECT}")
target_link_libraries(pfsoutyuv pfs)
install (TARGETS pfsoutyuv DESTINATION bin)
install (FILES pfsoutyuv.1 DESTINATION ${MAN_DIR})

add_executable(pfsinrgbe pfsinrgbe.cpp rgbeio.cpp rgbeio.h "${GETOPT_OBJECT}")
target_link_libraries(pfsinrgbe pfs)
install (TARGETS pfsinrgbe DESTINATION bin)
install (FILES pfsinrgbe.1 DESTINATION ${MAN_DIR})

add_executable(pfsoutrgbe pfsoutrgbe.cpp rgbeio.cpp rgbeio.h "${GETOPT_OBJECT}") 
target_link_libraries(pfsoutrgbe pfs)
install (TARGETS pfsoutrgbe DESTINATION bin)
install (FILES pfsoutrgbe.1 DESTINATION ${MAN_DIR})

add_executable(pfsinpfm pfsinpfm.cpp "${GETOPT_OBJECT}")
target_link_libraries(pfsinpfm pfs)
install (TARGETS pfsinpfm DESTINATION bin)
install (FILES pfsinpfm.1 DESTINATION ${MAN_DIR})

add_executable(pfsoutpfm pfsoutpfm.cpp "${GETOPT_OBJECT}")
target_link_libraries(pfsoutpfm pfs)
install (TARGETS pfsoutpfm DESTINATION bin)
install (FILES pfsoutpfm.1 DESTINATION ${MAN_DIR})

if( OPENEXR_FOUND )
    include_directories("${OPENEXR_INCLUDE_DIR}")

    add_executable(pfsinexr pfsinexr.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsinexr pfs ${OPENEXR_LIBRARIES})
    install (TARGETS pfsinexr DESTINATION bin)
    install (FILES pfsinexr.1 DESTINATION ${MAN_DIR})

    add_executable(pfsoutexr pfsoutexr.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsoutexr pfs ${OPENEXR_LIBRARIES})
    install (TARGETS pfsoutexr DESTINATION bin)
    install (FILES pfsoutexr.1 DESTINATION ${MAN_DIR})
 endif( OPENEXR_FOUND )

if( ImageMagick_FOUND )
    include_directories(${ImageMagick_INCLUDE_DIRS})
    add_executable(pfsinimgmagick pfsinimgmagick.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsinimgmagick pfs ${ImageMagick_LIBRARIES})
    install (TARGETS pfsinimgmagick DESTINATION bin)
    install (FILES pfsinimgmagick.1 DESTINATION ${MAN_DIR})
    set_target_properties(pfsinimgmagick PROPERTIES COMPILE_FLAGS "-DMAGICKCORE_HDRI_ENABLE=0 -DMAGICKCORE_QUANTUM_DEPTH=16")

    add_executable(pfsoutimgmagick pfsoutimgmagick.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsoutimgmagick pfs ${ImageMagick_LIBRARIES})
    install (TARGETS pfsoutimgmagick DESTINATION bin)
    install (FILES pfsoutimgmagick.1 DESTINATION ${MAN_DIR})
    set_target_properties(pfsoutimgmagick PROPERTIES COMPILE_FLAGS "-DMAGICKCORE_HDRI_ENABLE=0 -DMAGICKCORE_QUANTUM_DEPTH=16")

endif( ImageMagick_FOUND )

if( NETPBM_FOUND )

    include_directories(${NETPBM_INCLUDE_DIR})

    add_executable(pfsinppm pfsinppm.cpp ppmio.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsinppm pfs ${NETPBM_LIBRARIES})
    install (TARGETS pfsinppm DESTINATION bin)
    install (FILES pfsinppm.1 DESTINATION ${MAN_DIR})

    add_executable(pfsoutppm pfsoutppm.cpp ppmio.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsoutppm pfs ${NETPBM_LIBRARIES})
    install (TARGETS pfsoutppm DESTINATION bin)
    install (FILES pfsoutppm.1 DESTINATION ${MAN_DIR})

endif( NETPBM_FOUND )

if( TIFF_FOUND )

    include_directories(${TIFF_INCLUDE_DIR})

    add_executable(pfsintiff pfsintiff.cpp hdrtiffio.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsintiff pfs ${TIFF_LIBRARY})
    install (TARGETS pfsintiff DESTINATION bin)
    install (FILES pfsintiff.1 DESTINATION ${MAN_DIR})

    add_executable(pfsouttiff pfsouttiff.cpp hdrtiffio.cpp "${GETOPT_OBJECT}")
    target_link_libraries(pfsouttiff pfs ${TIFF_LIBRARY})
    install (TARGETS pfsouttiff DESTINATION bin)
    install (FILES pfsoutppm.1 DESTINATION ${MAN_DIR} RENAME pfsouttiff.1)

endif( TIFF_FOUND )

=== src/matlab/CMakeLists.txt ===
--- 
+++ 
@@ -52,10 +52,20 @@
 	SET( CMAKE_CXX_COMPILE_OBJECT 
 		"<CMAKE_CXX_COMPILER> <DEFINES> <FLAGS> ${INC_FLAGS} -outdir <OBJECT_DIR> -c <SOURCE>; cp <OBJECT_DIR>/$$(basename <SOURCE> .cpp ).obj <OBJECT>"
 	)
-else( CYGWIN ) 
-	SET( CMAKE_CXX_COMPILE_OBJECT 
-#		"<CMAKE_CXX_COMPILER> GCC='/usr/bin/gcc-4.7' <DEFINES> <FLAGS> ${INC_FLAGS} -outdir <OBJECT_DIR> -c <SOURCE>; mv <OBJECT_DIR>/$$(basename <SOURCE> .cpp ).o <OBJECT>"
-		"<CMAKE_CXX_COMPILER> <DEFINES> <FLAGS> -outdir <OBJECT_DIR> -c <SOURCE>"
+else( CYGWIN )
+
+  
+  if( MEXGCC )
+    set( GCC_COMMAND "GCC=${MEXGCC}" )
+    MESSAGE( STATUS "Using gcc for MEX: ${MEXGCC}.\n" )
+  else( MEXGCC )
+    set( GCC_COMMAND "" )
+  endif( MEXGCC )
+  
+  SET( CMAKE_CXX_COMPILE_OBJECT
+		"<CMAKE_CXX_COMPILER> ${GCC_COMMAND} <DEFINES> <FLAGS> ${INC_FLAGS} -outdir <OBJECT_DIR> -c <SOURCE>; mv <OBJECT_DIR>/$$(basename <SOURCE> .cpp ).o <OBJECT>"    
+#		"<CMAKE_CXX_COMPILER> <DEFINES> <FLAGS> ${INC_FLAGS} -outdir <OBJECT_DIR> -c <SOURCE>; mv <OBJECT_DIR>/$$(basename <SOURCE> .cpp ).o <OBJECT>"
+#		"<CMAKE_CXX_COMPILER> <DEFINES> <FLAGS> ${INC_FLAGS} -outdir <OBJECT_DIR> -c <SOURCE>"
 	)
 endif( CYGWIN ) 
 
@@ -65,7 +75,7 @@
  
 SET(
     CMAKE_CXX_CREATE_SHARED_LIBRARY
-    "<CMAKE_CXX_COMPILER> -cxx <LINK_FLAGS> <CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS> -output <TARGET> <OBJECTS> <LINK_LIBRARIES>"
+    "<CMAKE_CXX_COMPILER> ${GCC_COMMAND} -cxx <LINK_FLAGS> <CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS> -output <TARGET> <OBJECTS> <LINK_LIBRARIES>"
 #    "<CMAKE_CXX_COMPILER> GCC='/usr/bin/gcc-4.7' -cxx <LINK_FLAGS> <CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS> -output <TARGET> <OBJECTS> <LINK_LIBRARIES> LDFLAGS='$LDFLAGS -static-libstdc++'"
 )

=== src/tmo/fattal02/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/"
"${PROJECT_SOURCE_DIR}/src/pfs" "${PROJECT_SOURCE_DIR}/src/tmo/pfstmo")
if( NOT HAS_GETOPT )
	include_directories ("${GETOPT_INCLUDE}")
endif( NOT HAS_GETOPT )
link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

if( FFTW_FOUND AND OPENMP_FOUND)
  set( FFTW_LIBRARIES ${FFTW_LIBS} )
  set( PDE_FFT "pde_fft.cpp" )
  set( CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}" )
  set( CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_C_FLAGS}" )
else( FFTW_FOUND AND OPENMP_FOUND )
  set( FFTW_LIBRARIES )
endif( FFTW_FOUND AND OPENMP_FOUND )


set(TRG pfstmo_fattal02)
add_executable(${TRG} ${TRG}.cpp tmo_fattal02.cpp pde.cpp ${PDE_FFT} "${GETOPT_OBJECT}")
target_link_libraries(${TRG} pfs ${FFTW_LIBRARIES})
install (TARGETS ${TRG} DESTINATION bin)
install (FILES ${TRG}.1 DESTINATION ${MAN_DIR})

=== src/tmo/mantiuk06/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/"
"${PROJECT_SOURCE_DIR}/src/pfs" "${PROJECT_SOURCE_DIR}/src/tmo/pfstmo")
if( NOT HAS_GETOPT )
	include_directories ("${GETOPT_INCLUDE}")
endif( NOT HAS_GETOPT )
link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

set(TRG pfstmo_mantiuk06)
add_executable(${TRG} ${TRG}.cpp contrast_domain.cpp "${GETOPT_OBJECT}")
target_link_libraries(${TRG} pfs)
install (TARGETS ${TRG} DESTINATION bin)
install (FILES ${TRG}.1 DESTINATION ${MAN_DIR})

=== src/tmo/pattanaik00/CMakeLists.txt ===
include_directories ("${PROJECT_BINARY_DIR}/"
"${PROJECT_SOURCE_DIR}/src/pfs" "${PROJECT_SOURCE_DIR}/src/tmo/pfstmo")
if( NOT HAS_GETOPT )
	include_directories ("${GETOPT_INCLUDE}")
endif( NOT HAS_GETOPT )
link_directories("${PROJECT_SOURCE_DIR}/src/pfs")

set(TRG pfstmo_pattanaik00)
add_executable(${TRG} ${TRG}.cpp tmo_pattanaik00.cpp "${GETOPT_OBJECT}")
target_link_libraries(${TRG} pfs)
install (TARGETS ${TRG} DESTINATION bin)
install (FILES ${TRG}.1 DESTINATION ${MAN_DIR})

=== debian/changelog ===
pfstools (2.1.0-5build3) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:01:02 +0100

pfstools (2.1.0-5build2) focal; urgency=medium

  * No-change rebuild against libilmbase24 and libopenexr24.

 -- Rik Mills <rikmills@kde.org>  Mon, 02 Dec 2019 07:26:54 +0000

pfstools (2.1.0-5build1) focal; urgency=medium

  * Rebuild against new liboctave7.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 02 Nov 2019 20:51:55 +0100

pfstools (2.1.0-5) unstable; urgency=medium

  * 40_Fix-format-security-errors-with-Octave-5.1.patch: Fix FTBFS with octave
    5.1. Closes: #941742

 -- Andreas Metzler <ametzler@debian.org>  Fri, 04 Oct 2019 19:20:38 +0200

pfstools (2.1.0-4) unstable; urgency=medium

  * Run "wrap-and-sort --max-line-length=72 --short-indent".
  * [lintian] Point Vcs-* to salsa.
  * [lintian] Drop trailing empty line in changelog.
  * [lintian] Upgrade to dh compat 12. Suppress dh_dwz for octave-pfstools.
  * [lintian] Migration to new dbgsym package is finished.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 13 Jul 2019 14:34:38 +0200

pfstools (2.1.0-3) unstable; urgency=medium

  * 30_parallel_build.diff: Octave build requires libpfs, add CMake
    dependency.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 01 Jan 2018 17:47:47 +0100

pfstools (2.1.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Use debhelper v10 mode.
  * Use automatic debug packages.

 -- Andreas Metzler <ametzler@debian.org>  Mon, 01 Jan 2018 14:13:22 +0100

pfstools (2.1.0-1) experimental; urgency=low

  * [lintian] Delete trailing whitespace in changelog.
  * New upstream version.
    + Drop 30_Upgrade-to-Qt5.patch.
    + Bump libpfs shlibs.
  * Set Rules-Requires-Root: no

 -- Andreas Metzler <ametzler@debian.org>  Sat, 18 Nov 2017 12:55:15 +0100

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,37 @@
 Section: graphics
 Priority: optional
 Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
-Uploaders: Sebastian Harl <tokkee@debian.org>, Andreas Metzler <ametzler@debian.org>
-Build-Depends: debhelper (>= 9), gfortran,
- cmake, qtbase5-dev, libmagick++-dev, libtiff-dev, libopenexr-dev,
- libnetpbm10-dev, liboctave-dev, texlive-latex-base, freeglut3-dev,
- libgsl-dev
-Standards-Version: 4.1.1
+Uploaders:
+ Sebastian Harl <tokkee@debian.org>,
+ Andreas Metzler <ametzler@debian.org>
+Build-Depends:
+ cmake,
+ debhelper-compat (=12),
+ freeglut3-dev,
+ gfortran,
+ libgsl-dev,
+ libmagick++-dev,
+ libnetpbm10-dev,
+ liboctave-dev,
+ libopenexr-dev,
+ libtiff-dev,
+ qtbase5-dev,
+ texlive-latex-base
+Standards-Version: 4.4.0
+Rules-Requires-Root: no
 Homepage: http://pfstools.sourceforge.net/
-Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/pfstools.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-phototools/pfstools.git
+Vcs-Browser: https://salsa.debian.org/debian-phototools-team/pfstools
+Vcs-Git: https://salsa.debian.org/debian-phototools-team/pfstools.git
 
 Package: pfstools
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: pfsglview | pfsview, pfstmo, octave, octave-signal, octave-pfstools
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Recommends:
+ octave,
+ octave-pfstools,
+ octave-signal,
+ pfsglview | pfsview,
+ pfstmo
 Suggests: dcraw, exrtools, imagemagick
 Description: command line HDR manipulation programs
  pfstools is a set of command line (and two GUI) programs for reading,
@@ -29,7 +46,10 @@
 
 Package: pfsglview
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, pfstools (= ${binary:Version})
+Depends:
+ pfstools (= ${binary:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends}
 Replaces: pfstools (<< 1.6.2-2)
 Description: command line HDR manipulation programs (OpenGL/GLUT viewer)
  PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
@@ -40,7 +60,10 @@
 
 Package: pfsview
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, pfstools (= ${binary:Version})
+Depends:
+ pfstools (= ${binary:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends}
 Replaces: pfstools (<< 1.6.2-2)
 Description: command line HDR manipulation programs (Qt viewer)
  PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
@@ -48,20 +71,6 @@
  exchange data between applications.
  .
  This package contains a viewer implemented in Qt.
-
-Package: pfstools-dbg
-Section: debug
-Architecture: any
-Depends: pfstools (= ${binary:Version}), pfsglview (= ${binary:Version}),
- pfsview (= ${binary:Version}), libpfs2 (= ${binary:Version}),
- ${misc:Depends}
-Description: command line HDR manipulation programs (debugging symbols)
- PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
- existing file formats by providing a simple data format that can be used to
- exchange data between applications.
- .
- This package contains the debugging symbols for the pfstools binaries and the
- shared library.
 
 Package: libpfs-dev
 Section: libdevel
@@ -78,7 +87,7 @@
 Package: libpfs2
 Section: libs
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: C++ library to read and write pfs files
  PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
  existing file formats by providing a simple data format that can be used to
@@ -90,7 +99,7 @@
 Package: octave-pfstools
 Section: math
 Architecture: any
-Depends: octave, ${shlibs:Depends}, ${misc:Depends}
+Depends: octave, ${misc:Depends}, ${shlibs:Depends}
 Description: octave bindings for pfstools
  PFS is a high-dynamic range (HDR) image format. It is an attempt to integrate
  existing file formats by providing a simple data format that can be used to
@@ -100,7 +109,7 @@
 
 Package: pfstmo
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: pfstools
 Description: set of tone mapping operators
  This package contains a set of state-of-the-art tone mapping operators. Tone

=== debian/rules ===
--- 
+++ 
@@ -46,10 +46,13 @@
 		debian/pfstools/usr/share/man/*/pfstmo*
 
 override_dh_strip:
-	dh_strip --dbg-package=pfstools-dbg
 	# mkoctfile removes any symbol table and relocation information from the
 	# .oct files making them unusable for the -dbg package
-	rm -rf debian/pfstools-dbg/usr/lib/debug/usr/lib/octave/
+	dh_strip -poctave-pfstools --no-automatic-dbgsym
+	dh_strip --remaining-packages
+
+override_dh_dwz:
+	dh_dwz -X.oct
 
 override_dh_compress:
 	dh_compress -X.pdf
